class write_host_pid_curr_program
  {
    public:
    write_host_pid_curr_program(string& pathway)
    {
      int id;
      char char_host[5];
      string host_pid;

      ostringstream host_pid_stream;
      gethostname(char_host,4);
      char_host[4]=0;
      id=(int)getpid();

      host_pid_stream<<pathway<<char_host<<"."<<id;
      host_pid=host_pid_stream.str();
      write_host_pid.setf(ios::showpoint);
      write_host_pid.open(host_pid.c_str(),ios::trunc);
    }
    void  write_finish()
    {
       write_host_pid<<"FINISH"<<endl;
       write_host_pid.close();
    }
    private:
    ofstream write_host_pid;
  }; 
struct file_management
{
  ofstream*   output; 
  struct stat results;
  int err;
  file_management() 
  {}
  void init_output(ofstream* init_output)
  {
    output=init_output;
  }
  string& get_current_work_dir(string& main_dir)  
  {
    char PathName[1000];
    getcwd(PathName,1000);
    main_dir=PathName;
    main_dir+="/";
    return main_dir;
  }
  bool make_dir(string dir_name, mode_t i=0755)    
  {
    err=mkdir(dir_name.c_str(),i);
    if(err!=0) 
    {
      (*output)<<dir_name<<" :"<<strerror(errno)<<endl;
      return 0;
    }
    return true;
  }
  bool change_dir(string& dir_name)  
  {
    err=chdir(dir_name.c_str());
    if(err!=0) 
    {
      (*output)<<dir_name<<" :"<<strerror(errno)<<endl;
      return 0;
    }
    return true;
  }    
  bool check_dir(string& dir_name)  
  {
    struct stat results;
    stat(dir_name.c_str(), &results);
    return S_ISDIR(results.st_mode);
  }
  ofstream* open_new_file(string file_name)
  {
    ofstream* of;
    of=new ofstream(file_name.c_str(),ios::trunc);
    of->setf(ios::fixed);
    of->precision(5);
    return of;
  } 
  ofstream* open_exist_file(string file_name)
  {
    ofstream* of;
    of=new ofstream(file_name.c_str(),ios::app);
    of->setf(ios::fixed);
    of->precision(5);
   return of;
  }
  void close_file(ofstream* of)
  {
    of->close();
    delete of;
  }
};
